diff --git a/gcc/analyzer/constraint-manager.h b/gcc/analyzer/constraint-manager.h
new file mode 100644
index 0000000..5f0d3ca
--- /dev/null
+++ b/gcc/analyzer/constraint-manager.h
@@ -0,0 +1,243 @@
+/* Tracking equivalence classes and constraints at a point on an execution path.
+   Copyright (C) 2019 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_ANALYZER_CONSTRAINT_MANAGER_H
+#define GCC_ANALYZER_CONSTRAINT_MANAGER_H
+
+#include "region-model.h" // for svalue_id
+
+class superedge;
+class call_superedge;
+class return_superedge;
+
+class constraint_manager;
+
+/* One of the end-points of a range.  */
+
+struct bound
+{
+  bound () : m_constant (NULL_TREE), m_closed (false) {}
+  bound (tree constant, bool closed)
+  : m_constant (constant), m_closed (closed) {}
+
+  void ensure_closed (bool is_upper);
+
+  tree m_constant;
+  bool m_closed;
+};
+
+/* FIXME.  */
+
+struct range
+{
+  range () : m_lower_bound (), m_upper_bound () {}
+  range (const bound &lower, const bound &upper)
+  : m_lower_bound (lower), m_upper_bound (upper) {}
+
+  std::string to_str () const;
+
+  bool constrained_to_single_element (tree *out);
+
+  bound m_lower_bound;
+  bound m_upper_bound;
+};
+
+/* Abstract base class for specifying how state should be purged.  */
+
+class purge_criteria
+{
+public:
+  virtual ~purge_criteria () {}
+  virtual bool should_purge_p (svalue_id sid) const = 0;
+};
+
+/* FIXME.  */
+
+class equiv_class
+{
+public:
+  equiv_class ();
+  equiv_class (const equiv_class &other);
+  ~equiv_class ();
+
+  std::string to_str () const;
+  hashval_t hash () const;
+  bool operator== (const equiv_class &other);
+
+  void add (svalue_id sid, const constraint_manager &cm);
+  bool del (svalue_id sid);
+
+  tree get_any_constant () const { return m_constant; }
+
+  svalue_id get_representative () const;
+
+  void remap_svalue_ids (const svalue_id_map &map);
+
+  /* An equivalence class can contain at most one constant.  */
+  tree m_constant;
+  svalue_id m_cst_sid;
+
+  // FIXME: this is a bad representation, probably should be a set:
+  auto_vec<svalue_id> m_vars;
+
+  /* Has this value escaped from this function?  */
+  bool m_escaped;
+};
+
+enum constraint_op
+{
+  CONSTRAINT_NE,
+  CONSTRAINT_LT,
+  CONSTRAINT_LE
+};
+
+const char *constraint_op_code (enum constraint_op c_op);
+
+class equiv_class_id
+{
+public:
+  equiv_class_id (unsigned idx) : m_idx (idx) {}
+  const equiv_class &get_obj (const constraint_manager &cm) const;
+  equiv_class &get_obj (constraint_manager &cm) const;
+
+  bool operator== (const equiv_class_id &other) const
+  {
+    return m_idx == other.m_idx;
+  }
+  bool operator!= (const equiv_class_id &other) const
+  {
+    return m_idx != other.m_idx;
+  }
+
+  std::string to_str () const
+  {
+    return std::string ("ec") + std::to_string (m_idx);
+  }
+
+  void update_for_removal (equiv_class_id other)
+  {
+    if (m_idx > other.m_idx)
+      m_idx--;
+  }
+
+  unsigned m_idx;
+};
+
+class constraint {
+ public:
+  constraint (equiv_class_id lhs, enum constraint_op c_op, equiv_class_id rhs)
+    : m_lhs (lhs), m_op (c_op), m_rhs (rhs) {}
+
+  std::string to_str (const constraint_manager &cm) const;
+  hashval_t hash () const;
+  bool operator== (const constraint &other) const;
+
+  /* Is this an ordering, rather than a "!=".  */
+  bool is_ordering_p () const
+  {
+    return m_op != CONSTRAINT_NE;
+  }
+
+  equiv_class_id m_lhs;
+  enum constraint_op m_op;
+  equiv_class_id m_rhs;
+};
+
+/* FIXME.  */
+
+class constraint_manager
+{
+public:
+  constraint_manager () {}
+  constraint_manager (const constraint_manager &other);
+  virtual ~constraint_manager ();
+
+  virtual constraint_manager *clone (region_model *) const = 0;
+  virtual tree maybe_get_constant (svalue_id sid) const = 0;
+  virtual svalue_id get_sid_for_constant (tree cst) const = 0;
+  virtual int get_num_svalues () const = 0;
+
+  constraint_manager& operator= (const constraint_manager &other);
+
+  hashval_t hash () const;
+  bool operator== (const constraint_manager &other) const;
+  bool operator!= (const constraint_manager &other) const
+  {
+    return !(*this == other);
+  }
+
+  std::string to_str () const;
+  void print (pretty_printer *pp) const;
+  void dump_to_pp (pretty_printer *pp) const;
+  void dump (FILE *fp) const;
+  void dump () const;
+
+  const equiv_class &get_equiv_class_by_index (unsigned idx) const
+  {
+    return *m_equiv_classes[idx];
+  }
+  equiv_class &get_equiv_class_by_index (unsigned idx)
+  {
+    return *m_equiv_classes[idx];
+  }
+
+  equiv_class &get_equiv_class (svalue_id sid)
+  {
+    equiv_class_id ec_id = get_or_add_equiv_class (sid);
+    return ec_id.get_obj (*this);
+  }
+
+  bool add_constraint (svalue_id lhs, enum tree_code op, svalue_id rhs);
+
+  bool add_constraint (equiv_class_id lhs_ec_id,
+		       enum tree_code op,
+		       equiv_class_id rhs_ec_id);
+
+  bool get_equiv_class (svalue_id sid, equiv_class_id *out) const;
+  equiv_class_id get_or_add_equiv_class (svalue_id sid);
+  tristate eval_condition (equiv_class_id lhs,
+			   enum tree_code op,
+			   equiv_class_id rhs);
+  tristate eval_condition (svalue_id lhs,
+			   enum tree_code op,
+			   svalue_id rhs);
+
+  /* For implementing "__analyzer_eval".  */
+  tristate dump_condition (tree lhs, enum tree_code op, tree rhs);
+
+  void recursively_mark_as_escaping (equiv_class_id ec_id);
+  bool calc_escaped_p (svalue_id sid);
+
+  void purge (const purge_criteria &p, purge_stats *stats);
+
+  void remap_svalue_ids (const svalue_id_map &map);
+
+  void validate () const;
+
+  auto_vec<equiv_class *> m_equiv_classes;
+  auto_vec<constraint> m_constraints;
+
+ private:
+  void add_constraint_internal (equiv_class_id lhs_id,
+				enum constraint_op c_op,
+				equiv_class_id rhs_id);
+};
+
+#endif /* GCC_ANALYZER_CONSTRAINT_MANAGER_H */
diff --git a/gcc/analyzer/digraph.cc b/gcc/analyzer/digraph.cc
index d03fd6b..f7c1ce1 100644
--- a/gcc/analyzer/digraph.cc
+++ b/gcc/analyzer/digraph.cc
@@ -49,6 +49,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "graphviz.h"
 #include "cgraph.h"
 #include "digraph.h"
+#include "tree-diagnostic.h"
 
 void
 digraph::dump_dot_to_pp (pretty_printer *pp, cluster *root_cluster) const
@@ -106,6 +107,7 @@ void
 digraph::dump_dot_to_file (FILE *fp, cluster *root_cluster) const
 {
   pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
   pp.buffer->stream = fp;
   dump_dot_to_pp (&pp, root_cluster);
   pp_flush (&pp);
diff --git a/gcc/analyzer/digraph.h b/gcc/analyzer/digraph.h
index 54275d3..6f923ee 100644
--- a/gcc/analyzer/digraph.h
+++ b/gcc/analyzer/digraph.h
@@ -94,4 +94,77 @@ class cluster
   virtual void dump_dot (graphviz_out *gv) const = 0;
 };
 
+#if 0
+////////////////////////////////////////////////////////////////////////////
+
+template <typename GraphTraits>
+class base_node
+{
+ public:
+  typedef typename GraphTraits::edge_t edge_t;
+
+  void dump_dot (graphviz_out *gv) const;
+
+ protected:
+  auto_vec<edge_t *> m_succs;
+};
+
+template <typename GraphTraits>
+class base_edge
+{
+ public:
+  typedef typename GraphTraits::node_t node_t;
+
+  base_edge (node_t *src, node_t *dest)
+  : m_src (src), m_dest (dest) {}
+
+  void dump_dot (graphviz_out *gv) const;
+
+ protected:
+  node_t *m_src;
+  node_t *m_dest;
+};
+
+template <typename GraphTraits>
+class base_graph
+{
+ public:
+  typedef typename GraphTraits::node_t node_t;
+  typedef typename GraphTraits::edge_t edge_t;
+
+  void dump_dot (graphviz_out *gv) const;
+
+ protected:
+  auto_vec<node_t *> m_nodes;
+  auto_vec<edge_t *> m_edge;
+};
+
+////////////////////////////////////////////////////////////////////////////
+
+/* Curiously-recurring template pattern, for node/edge/graph.  */
+
+struct test_node;
+struct test_edge;
+struct test_graph;
+
+struct test_traits
+{
+  typedef test_node node_t;
+  typedef test_edge edge_t;
+  typedef test_graph graph_t;
+};
+
+struct test_node : public base_node<test_traits>
+{
+};
+
+struct test_edge : public base_edge<test_traits>
+{
+};
+
+struct test_graph : public base_graph<test_traits>
+{
+};
+#endif
+
 #endif /* GCC_ANALYZER_DIGRAPH_H */
diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 5281c16..873c990 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -1075,7 +1075,7 @@ public:
   auto_vec <link> m_links; // FIXME: copy-ctor etc
 };
 
-#include "constraints.h" // FIXME
+#include "path-state.h" // FIXME
 
 class candidate_diagnostic
 {
@@ -1412,8 +1412,8 @@ public:
 
     // FIXME: do it for everything in the equivalence class
     // FIXME: stack depth:
-    equiv_class_id ec_id = m_ps->get_or_add_equiv_class (path_var (var, 0));
-    equiv_class &ec = ec_id.get_obj (*m_ps);
+    psn::equiv_class_id ec_id = m_ps->get_or_add_equiv_class (path_var (var, 0));
+    psn::equiv_class &ec = ec_id.get_obj (*m_ps);
 
     if (m_engine->get_logger ())
       m_engine->log ("considering equivalence class: %s",
@@ -1865,8 +1865,8 @@ engine::on_stmt (const supernode *node, const gimple *stmt,
 	       this path, and record the result, if known.  */
 	    tree rhs2 = gimple_assign_rhs2 (assign);
 	    // FIXME: stack depths:
-	    equiv_class_id rhs1_ec_id = ps->get_or_add_equiv_class (path_var (rhs1, 0));
-	    equiv_class_id rhs2_ec_id = ps->get_or_add_equiv_class (path_var (rhs2, 0));
+	    psn::equiv_class_id rhs1_ec_id = ps->get_or_add_equiv_class (path_var (rhs1, 0));
+	    psn::equiv_class_id rhs2_ec_id = ps->get_or_add_equiv_class (path_var (rhs2, 0));
 	    tristate t = ps->eval_condition (rhs1_ec_id, op, rhs2_ec_id);
 	    if (get_logger ())
 	      log ("eval condition: %s", t.as_string ());
@@ -2604,7 +2604,7 @@ engine::detect_leaks (const supernode *node, const sm_instance &sm_inst,
       {
 	log ("new_ps before escapes: %s", new_ps.to_str ().c_str ());
 	// FIXME: stack depth:
-	equiv_class_id ec_id
+	psn::equiv_class_id ec_id
 	  = new_ps.get_or_add_equiv_class (path_var (result, 0));
 	new_ps.recursively_mark_as_escaping (ec_id);
 	log ("new_ps after escapes: %s", new_ps.to_str ().c_str ());
@@ -2641,9 +2641,9 @@ engine::detect_leaks (const supernode *node, const sm_instance &sm_inst,
        /* Did this var's equivalence class escape?  If so, don't complain
 	 about it leaking.  */
       // FIXME: stack depth:
-      equiv_class_id ec_id
+      psn::equiv_class_id ec_id
 	= new_ps.get_or_add_equiv_class (path_var (vs->m_var, 0));
-      equiv_class &ec = ec_id.get_obj (new_ps);
+      psn::equiv_class &ec = ec_id.get_obj (new_ps);
       if (get_logger ())
 	log ("within %s", ec.to_str ().c_str ());
       if (ec.m_escaped)
@@ -3813,7 +3813,6 @@ run_checkers_impl_2 ()
       }
 
 #if 0
-    // TODO: selftest for auto_delete_vec
     auto_delete_vec <state_machine> checkers;
     make_checkers (checkers, the_logger.get_logger ());
 
diff --git a/gcc/analyzer/hardcoded-state-machine-file.cc b/gcc/analyzer/hardcoded-state-machine-file.cc
index 8d74298..0c4f821 100644
--- a/gcc/analyzer/hardcoded-state-machine-file.cc
+++ b/gcc/analyzer/hardcoded-state-machine-file.cc
@@ -40,14 +40,20 @@ static const bool DEBUG = false;
 
 ////////////////////////////////////////////////////////////////////////////
 
-class double_fclose : public pending_diagnostic
+class double_fclose : public pending_diagnostic_subclass<double_fclose>
 {
 public:
   double_fclose (tree arg) : m_arg (arg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "double_fclose"; }
+  bool operator== (const double_fclose &other) const
+  {
+    return m_arg == other.m_arg;
+  }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
-    warning_at (rich_loc, 0,
+    warning_at (rich_loc, OPT_Wanalyzer_double_fclose,
 		"double %<fclose%> of FILE %qE",
 		m_arg);
   }
@@ -56,16 +62,24 @@ private:
   tree m_arg;
 };
 
-class file_leak : public pending_diagnostic
+class file_leak : public pending_diagnostic_subclass<file_leak>
 {
 public:
   file_leak (tree arg) : m_arg (arg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "file_leak"; }
+  bool operator== (const file_leak &other) const
+  {
+    return m_arg == other.m_arg;
+  }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     metadata m;
+    /* CWE-775: "Missing Release of File Descriptor or Handle after
+       Effective Lifetime". */
     m.add_cwe (775);
-    warning_at (rich_loc, 0,
+    warning_at (rich_loc, m, OPT_Wanalyzer_file_leak,
 		"leak of FILE %qE",
 		m_arg);
   }
@@ -88,7 +102,7 @@ fileptr_state_machine::fileptr_state_machine (logger *logger)
   m_stop = add_state ("stop");
 }
 
-void
+bool
 fileptr_state_machine::on_stmt (sm_context *sm_ctxt,
 				const supernode *node,
 				const gimple *stmt) const
@@ -109,6 +123,7 @@ fileptr_state_machine::on_stmt (sm_context *sm_ctxt,
 	    {
 	      /* TODO: report leak.  */
 	    }
+	  return true;
 	}
 
       if (is_named_call_p (call, "fclose", 1))
@@ -127,11 +142,13 @@ fileptr_state_machine::on_stmt (sm_context *sm_ctxt,
 	  sm_ctxt->warn_for_state (node, stmt, arg, m_closed,
 				   new double_fclose (arg));
 	  sm_ctxt->on_transition (node, stmt, arg, m_closed, m_stop);
+	  return true;
 	}
 
       // TODO: operations on closed file
       // etc
     }
+  return false;
 }
 
 /* FIXME.  */
@@ -190,3 +207,9 @@ fileptr_state_machine::on_leak (sm_context *sm_ctxt,
   sm_ctxt->warn_for_state (node, stmt, var, m_nonnull,
 			   new file_leak (var));
 }
+
+bool
+fileptr_state_machine::can_purge_p (state_t s) const
+{
+  return s != m_unchecked && s != m_nonnull;
+}
diff --git a/gcc/analyzer/hardcoded-state-machine-malloc.cc b/gcc/analyzer/hardcoded-state-machine-malloc.cc
index cf61b0d..9704bae 100644
--- a/gcc/analyzer/hardcoded-state-machine-malloc.cc
+++ b/gcc/analyzer/hardcoded-state-machine-malloc.cc
@@ -47,6 +47,11 @@ public:
   : m_sm (sm), m_arg (arg)
   {}
 
+  bool subclass_equal_p (const pending_diagnostic &base_other) const OVERRIDE
+  {
+    return m_arg == ((const malloc_diagnostic &)base_other).m_arg;
+  }
+
 protected:
   const malloc_state_machine &m_sm;
   tree m_arg;
@@ -59,12 +64,15 @@ public:
   : malloc_diagnostic (sm, arg)
   {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "double_free"; }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     auto_diagnostic_group d;
     metadata m;
     m.add_cwe (415); /* CWE-415: Double Free.  */
-    warning_at (rich_loc, m, "double-free of %qE", m_arg);
+    warning_at (rich_loc, m, OPT_Wanalyzer_double_free,
+		"double-free of %qE", m_arg);
 
 #if 0
     if (!rich_loc->get_path ())
@@ -120,19 +128,15 @@ private:
   //event_id_t m_second_free_event;
 };
 
-class possible_null_deref : public malloc_diagnostic
+/* Abstract subclass for describing possible bad uses of NULL.
+   Responsible for describing the call that could return NULL.  */
+
+class possible_null : public malloc_diagnostic
 {
 public:
-  possible_null_deref (const malloc_state_machine &sm, tree arg)
-  : malloc_diagnostic (sm, arg) {}
-
-  void emit (rich_location *rich_loc) FINAL OVERRIDE
-  {
-    /* CWE-690: Unchecked Return Value to NULL Pointer Dereference.  */
-    metadata m;
-    m.add_cwe (690);
-    warning_at (rich_loc, m, "use of possibly-NULL %qE", m_arg);
-  }
+  possible_null (const malloc_state_machine &sm, tree arg)
+  : malloc_diagnostic (sm, arg)
+  {}
 
   label_text describe_critical_state_change (tree expr,
 					     state_machine::state_t old_state,
@@ -144,6 +148,28 @@ public:
       return label_text::borrow ("this call could return NULL");
     return label_text ();
   }
+};
+
+/* Concrete subclass for describing dereference of a possible NULL
+   value.  */
+
+class possible_null_deref : public possible_null
+{
+public:
+  possible_null_deref (const malloc_state_machine &sm, tree arg)
+  : possible_null (sm, arg)
+  {}
+
+  const char *get_kind () const FINAL OVERRIDE { return "possible_null_deref"; }
+
+  void emit (rich_location *rich_loc) FINAL OVERRIDE
+  {
+    /* CWE-690: Unchecked Return Value to NULL Pointer Dereference.  */
+    metadata m;
+    m.add_cwe (690);
+    warning_at (rich_loc, m, OPT_Wanalyzer_possible_null_dereference,
+		"use of possibly-NULL %qE", m_arg);
+  }
 
   /* FIXME.  */
   label_text describe_final_event
@@ -156,21 +182,146 @@ public:
 
 };
 
+/* Subroutine for use by possible_null_arg::emit and null_arg::emit.
+   Issue a note informing that the pertinent argument must be non-NULL.  */
+
+static void
+inform_nonnull_attribute (tree fndecl, int arg_idx)
+{
+  inform (DECL_SOURCE_LOCATION (fndecl),
+	  "argument %u of %qD must be non-null",
+	  arg_idx + 1, fndecl);
+  /* FIXME: ideally, use the location of the parm
+     and underline the attribute also (but we probably don't have the
+     location_t...)  */
+
+  /* C and C++ FEs have get_fndecl_argument_location.  */
+}
+
+/* Concrete subclass for describing passing a possibly-NULL value to a
+   function marked with __attribute__((nonnull)).  */
+
+class possible_null_arg : public possible_null
+{
+public:
+  possible_null_arg (const malloc_state_machine &sm, tree arg,
+		     tree fndecl, int arg_idx)
+  : possible_null (sm, arg),
+    m_fndecl (fndecl), m_arg_idx (arg_idx)
+  {}
+
+  const char *get_kind () const FINAL OVERRIDE { return "possible_null_arg"; }
+
+  bool subclass_equal_p (const pending_diagnostic &base_other) const
+  {
+    const possible_null_arg &sub_other
+      = (const possible_null_arg &)base_other;
+    return (m_arg == sub_other.m_arg
+	    && m_fndecl == sub_other.m_fndecl
+	    && m_arg_idx == sub_other.m_arg_idx);
+  }
+
+
+  void emit (rich_location *rich_loc) FINAL OVERRIDE
+  {
+    /* CWE-690: Unchecked Return Value to NULL Pointer Dereference.  */
+    auto_diagnostic_group d;
+    metadata m;
+    m.add_cwe (690);
+    warning_at (rich_loc, m, OPT_Wanalyzer_possible_null_argument,
+		"use of possibly-NULL %qE where non-null expected",
+		m_arg);
+    inform_nonnull_attribute (m_fndecl, m_arg_idx);
+  }
+
+  /* FIXME.  */
+  label_text describe_final_event
+    (/*diagnostic_context *ctxt, */
+     tree expr,
+     state_machine::state_t state ATTRIBUTE_UNUSED)
+  {
+    return formatted_print ("argument %u (%qE) could be NULL"
+			    " where non-null expected",
+			    m_arg_idx + 1, expr);
+  }
+
+  // TODO
+
+private:
+  tree m_fndecl;
+  int m_arg_idx;
+};
+
+/* Concrete subclass for describing a dereference of a NULL value.  */
+
 class null_deref : public malloc_diagnostic
 {
 public:
   null_deref (const malloc_state_machine &sm, tree arg)
   : malloc_diagnostic (sm, arg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "null_deref"; }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     /* CWE-690: Unchecked Return Value to NULL Pointer Dereference.  */
     metadata m;
     m.add_cwe (690);
-    warning_at (rich_loc, m, "use of NULL %qE", m_arg);
+    warning_at (rich_loc, m, OPT_Wanalyzer_null_dereference,
+		"use of NULL %qE", m_arg);
   }
 };
 
+/* Concrete subclass for describing passing a NULL value to a
+   function marked with __attribute__((nonnull)).  */
+
+class null_arg : public malloc_diagnostic
+{
+public:
+  null_arg (const malloc_state_machine &sm, tree arg,
+	    tree fndecl, int arg_idx)
+  : malloc_diagnostic (sm, arg),
+    m_fndecl (fndecl), m_arg_idx (arg_idx)
+  {}
+
+  const char *get_kind () const FINAL OVERRIDE { return "null_arg"; }
+
+  bool subclass_equal_p (const pending_diagnostic &base_other) const
+  {
+    const null_arg &sub_other
+      = (const null_arg &)base_other;
+    return (m_arg == sub_other.m_arg
+	    && m_fndecl == sub_other.m_fndecl
+	    && m_arg_idx == sub_other.m_arg_idx);
+  }
+
+  void emit (rich_location *rich_loc) FINAL OVERRIDE
+  {
+    /* CWE-690: Unchecked Return Value to NULL Pointer Dereference.  */
+    auto_diagnostic_group d;
+    metadata m;
+    m.add_cwe (690);
+    warning_at (rich_loc, m, OPT_Wanalyzer_null_argument,
+		"use of NULL %qE where non-null expected", m_arg);
+    inform_nonnull_attribute (m_fndecl, m_arg_idx);
+  }
+
+  /* FIXME.  */
+  label_text describe_final_event
+    (/*diagnostic_context *ctxt, */
+     tree expr,
+     state_machine::state_t state ATTRIBUTE_UNUSED)
+  {
+    return formatted_print ("argument %u (%qE) NULL"
+			    " where non-null expected",
+			    m_arg_idx + 1, expr);
+  }
+
+private:
+  tree m_fndecl;
+  int m_arg_idx;
+};
+
 class use_after_free : public malloc_diagnostic
 {
 public:
@@ -178,12 +329,15 @@ public:
   : malloc_diagnostic (sm, arg)
   {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "use_after_free"; }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     /* CWE-416: Use After Free.  */
     metadata m;
     m.add_cwe (416);
-    warning_at (rich_loc, m, "use after free of %qE", m_arg);
+    warning_at (rich_loc, m, OPT_Wanalyzer_use_after_free,
+		"use after free of %qE", m_arg);
   }
 
   label_text describe_critical_state_change (tree expr,
@@ -204,11 +358,14 @@ public:
   malloc_leak (const malloc_state_machine &sm, tree arg)
   : malloc_diagnostic (sm, arg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "malloc_leak"; }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     metadata m;
     m.add_cwe (401);
-    warning_at (rich_loc, m, "leak of %qE", m_arg);
+    warning_at (rich_loc, m, OPT_Wanalyzer_malloc_leak,
+		"leak of %qE", m_arg);
   }
 
   label_text describe_critical_state_change (tree expr,
@@ -241,6 +398,15 @@ public:
   {
   }
 
+  const char *get_kind () const FINAL OVERRIDE { return "free_of_non_heap"; }
+
+  bool subclass_equal_p (const pending_diagnostic &base_other) const
+    FINAL OVERRIDE
+  {
+    const free_of_non_heap &other = (const free_of_non_heap &)base_other;
+    return (m_arg == other.m_arg && m_kind == other.m_kind);
+  }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     auto_diagnostic_group d;
@@ -251,12 +417,12 @@ public:
       default:
 	gcc_unreachable ();
       case KIND_UNKNOWN:
-	warning_at (rich_loc, m,
+	warning_at (rich_loc, m, OPT_Wanalyzer_free_of_non_heap,
 		    "free of %qE which points to memory not on the heap",
 		    m_arg);
 	break;
       case KIND_ALLOCA:
-	warning_at (rich_loc, m,
+	warning_at (rich_loc, m, OPT_Wanalyzer_free_of_non_heap,
 		    "free of memory allocated on the stack by %qs (%qE)"
 		    " will corrupt the heap",
 		    "alloca", m_arg);
@@ -323,7 +489,7 @@ malloc_state_machine::malloc_state_machine (logger *logger)
   m_stop = add_state ("stop");
 }
 
-void
+bool
 malloc_state_machine::on_stmt (sm_context *sm_ctxt,
 			       const supernode *node,
 			       const gimple *stmt) const
@@ -345,6 +511,7 @@ malloc_state_machine::on_stmt (sm_context *sm_ctxt,
 	    {
 	      /* TODO: report leak.  */
 	    }
+	  return true;
 	}
 
       if (is_named_call_p (call, "alloca", 1)
@@ -353,6 +520,7 @@ malloc_state_machine::on_stmt (sm_context *sm_ctxt,
 	  tree lhs = gimple_call_lhs (call);
 	  if (lhs)
 	    sm_ctxt->on_transition (node, stmt, lhs, m_start, m_non_heap);
+	  return true;
 	}
 
       if (is_named_call_p (call, "free", 1))
@@ -378,6 +546,40 @@ malloc_state_machine::on_stmt (sm_context *sm_ctxt,
 	  sm_ctxt->warn_for_state (node, stmt, arg, m_non_heap,
 				   new free_of_non_heap (*this, arg));
 	  sm_ctxt->on_transition (node, stmt, arg, m_non_heap, m_stop);
+	  return true;
+	}
+
+      /* TODO: handle "__attribute__((nonnull))".   */
+      if (tree callee_fndecl = gimple_call_fndecl (stmt))
+	{
+	  tree fntype = TREE_TYPE (callee_fndecl);
+	  bitmap nonnull_args = get_nonnull_args (fntype);
+	  if (nonnull_args)
+	    {
+	      for (unsigned i = 0; i < gimple_call_num_args (stmt); i++)
+		{
+		  tree arg = gimple_call_arg (stmt, i);
+		  if (TREE_CODE (TREE_TYPE (arg)) != POINTER_TYPE)
+		    continue;
+		  /* If we have a nonnull-args, and either all pointers, or just
+		     the specified pointers.  */
+		  if (bitmap_empty_p (nonnull_args)
+		      || bitmap_bit_p (nonnull_args, i))
+		    {
+		      sm_ctxt->warn_for_state
+			(node, stmt, arg, m_unchecked,
+			 new possible_null_arg (*this, arg, callee_fndecl, i));
+		      sm_ctxt->on_transition (node, stmt, arg, m_unchecked,
+					      m_nonnull);
+
+		      sm_ctxt->warn_for_state
+			(node, stmt, arg, m_null,
+			 new null_arg (*this, arg, callee_fndecl, i));
+		      sm_ctxt->on_transition (node, stmt, arg, m_null, m_stop);
+		    }
+		}
+	      BITMAP_FREE (nonnull_args);
+	    }
 	}
     }
 
@@ -437,6 +639,7 @@ malloc_state_machine::on_stmt (sm_context *sm_ctxt,
 	  sm_ctxt->on_transition (node, stmt, arg, m_free, m_stop);
 	}
     }
+  return false;
 }
 
 /* FIXME.  */
@@ -494,3 +697,9 @@ malloc_state_machine::on_leak (sm_context *sm_ctxt,
   sm_ctxt->warn_for_state (node, stmt, var, m_nonnull,
 			   new malloc_leak (*this, var));
 }
+
+bool
+malloc_state_machine::can_purge_p (state_t s) const
+{
+  return s != m_unchecked && s != m_nonnull;
+}
diff --git a/gcc/analyzer/hardcoded-state-machine-pattern-test.cc b/gcc/analyzer/hardcoded-state-machine-pattern-test.cc
index 7f1460c..bef3bcb 100644
--- a/gcc/analyzer/hardcoded-state-machine-pattern-test.cc
+++ b/gcc/analyzer/hardcoded-state-machine-pattern-test.cc
@@ -40,11 +40,20 @@ static const bool DEBUG = false;
 
 ////////////////////////////////////////////////////////////////////////////
 
-class pattern_match : public pending_diagnostic
+class pattern_match : public pending_diagnostic_subclass<pattern_match>
 {
 public:
   pattern_match (tree arg, const char *msg) : m_arg (arg), m_msg (msg) {}
 
+  const char *get_kind () const FINAL OVERRIDE { return "pattern_match"; }
+
+  bool operator== (const pattern_match &other) const
+  {
+    return (m_arg == other.m_arg
+	    // FIXME: should this be string equality?
+	    && m_msg == other.m_msg);
+  }
+
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     // TODO:
@@ -65,7 +74,7 @@ pattern_test_state_machine::pattern_test_state_machine (logger *logger)
   m_start = add_state ("start");
 }
 
-void
+bool
 pattern_test_state_machine::on_stmt (sm_context *sm_ctxt,
 				     const supernode *node,
 				     const gimple *stmt) const
@@ -76,6 +85,7 @@ pattern_test_state_machine::on_stmt (sm_context *sm_ctxt,
   if (const gcall *call = dyn_cast <const gcall *> (stmt))
     {
     }
+  return false;
 }
 
 /* FIXME.  */
@@ -129,3 +139,9 @@ pattern_test_state_machine::on_leak (sm_context *sm_ctxt,
 {
   /* Empty.  */
 }
+
+bool
+pattern_test_state_machine::can_purge_p (state_t s) const
+{
+  return true;
+}
diff --git a/gcc/analyzer/hardcoded-state-machine-sensitive.cc b/gcc/analyzer/hardcoded-state-machine-sensitive.cc
index 59e5cb7..5c52431 100644
--- a/gcc/analyzer/hardcoded-state-machine-sensitive.cc
+++ b/gcc/analyzer/hardcoded-state-machine-sensitive.cc
@@ -40,17 +40,25 @@ static const bool DEBUG = false;
 
 ////////////////////////////////////////////////////////////////////////////
 
-class leakage_through_output_file : public pending_diagnostic
+class exposure_through_output_file
+  : public pending_diagnostic_subclass<exposure_through_output_file>
 {
 public:
-  leakage_through_output_file (tree arg) : m_arg (arg) {}
+  exposure_through_output_file (tree arg) : m_arg (arg) {}
+
+  const char *get_kind () const FINAL OVERRIDE { return "exposure_through_output_file"; }
+
+  bool operator== (const exposure_through_output_file &other) const
+  {
+    return m_arg == other.m_arg;
+  }
 
   void emit (rich_location *rich_loc) FINAL OVERRIDE
   {
     metadata m;
     /* CWE-532: Information Exposure Through Log Files */
     m.add_cwe (532);
-    warning_at (rich_loc, m,
+    warning_at (rich_loc, m, OPT_Wanalyzer_exposure_through_output_file,
 		"sensitive value %qE written to output file",
 		m_arg);
   }
@@ -71,16 +79,16 @@ sensitive_state_machine::sensitive_state_machine (logger *logger)
 }
 
 void
-sensitive_state_machine::warn_for_any_leakage (sm_context *sm_ctxt,
-					       const supernode *node,
-					       const gimple *stmt,
-					       tree arg) const
+sensitive_state_machine::warn_for_any_exposure (sm_context *sm_ctxt,
+						const supernode *node,
+						const gimple *stmt,
+						tree arg) const
 {
   sm_ctxt->warn_for_state (node, stmt, arg, m_sensitive,
-			   new leakage_through_output_file (arg));
+			   new exposure_through_output_file (arg));
 }
 
-void
+bool
 sensitive_state_machine::on_stmt (sm_context *sm_ctxt,
 				  const supernode *node,
 				  const gimple *stmt) const
@@ -95,6 +103,7 @@ sensitive_state_machine::on_stmt (sm_context *sm_ctxt,
 	  tree lhs = gimple_call_lhs (call);
 	  if (lhs)
 	    sm_ctxt->on_transition (node, stmt, lhs, m_start, m_sensitive);
+	  return true;
 	}
       else if (is_named_call_p (call, "fprintf")
 	       || is_named_call_p (call, "printf"))
@@ -103,15 +112,18 @@ sensitive_state_machine::on_stmt (sm_context *sm_ctxt,
 	  for (int idx = 1; idx < gimple_call_num_args (call); idx++)
 	    {
 	      tree arg = gimple_call_arg (call, idx);
-	      warn_for_any_leakage (sm_ctxt, node, stmt, arg);
+	      warn_for_any_exposure (sm_ctxt, node, stmt, arg);
 	    }
+	  return true;
 	}
       else if (is_named_call_p (call, "fwrite", 4))
 	{
 	  tree arg = gimple_call_arg (call, 0);
-	  warn_for_any_leakage (sm_ctxt, node, stmt, arg);
+	  warn_for_any_exposure (sm_ctxt, node, stmt, arg);
+	  return true;
 	}
     }
+  return false;
 }
 
 /* FIXME.  */
@@ -133,3 +145,9 @@ sensitive_state_machine::on_leak (sm_context *sm_ctxt,
 {
   /* Empty.  */
 }
+
+bool
+sensitive_state_machine::can_purge_p (state_t s) const
+{
+  return true;
+}
